---
# tasks file for libvirt
- name: install dependencies
  package:
    name: "{{ item }}"
    state: present
  with_items: "{{ dependencies }}"
  tags:
    - never
    - create_vm

- name: start libvirtd
  systemd:
    name: libvirtd
    state: started
    enabled: yes
  tags:
   - never
   - create_vm

- name: get list of VMs
  virt:
    command: list_vms
  register: vms
  tags:
    - always

- name: create vm
  block:
    - name: create vm => get VM disks
      command: "ls {{ vms_location }}"
      register: disks
      changed_when: "disks.rc != 0"
    - name: create vm => disk
      command: >
          virt-builder --hostname {{ item.key }} --format qcow2 {{ os_template }}
          -o {{ vms_location }}/{{ item.key }}.{{ item.value.file_type }}
          --root-password password:{{ root_pass }}
          --size {{ item.value.disk_size }}
          --timezone America/Sao_Paulo
          --firstboot-command 'useradd -m -p "" remoto ; chage -d 0 remoto'
          --firstboot-command 'yum -y update ; usermod -aG wheel remoto'
      when: item.key not in disks.stdout
      with_dict: "{{ guests }}"
    - name: create vm => vm
      command: >
          virt-install --import --name {{ item.key }}
          --memory {{ item.value.mem }} --vcpus {{ item.value.cpus }}
          --network=bridge:virbr0 --disk {{ vms_location }}/{{ item.key }}.{{ item.value.file_type }}
          --noautoconsole --os-variant {{ item.value.os_type }}
      when: item.key not in vms.list_vms
      with_dict: "{{ guests }}"
    - name: create vm => start vm
      virt:
        name: "{{ item.key }}"
        state: running
      with_dict: "{{ guests }}"
  tags:
    - never
    - create_vm

- name: destroy vm
  block:
    - name: destroy vm => shutdown
      virt:
        name: "{{ item.key }}"
        state: destroyed
      when: item.key in vms.list_vms
      with_dict: "{{ guests }}"
    - name: destroy vm => undefined
      virt:
        name: "{{ item.key }}"
        command: undefine
      when: item.key in vms.list_vms
      with_dict: "{{ guests }}"

    - name: List Files
      find:
        file_type: file
        paths: "{{ vms_location }}"
        patterns: "*.qcow2"
      register: qcow2

    - name: Cleanup folders
      file:
        path: "{{item.path}}"
        state: absent
      loop: "{{qcow2.files}}"
      when: qcow2.matched >= 1
  tags:
    - never
    - destroy_vm

